import { Component, OnInit } from '@angular/core';
import { NgbDate, NgbCalendar, NgbDateParserFormatter } from '@ng-bootstrap/ng-bootstrap';
import { NgbModal, ModalDismissReasons } from '@ng-bootstrap/ng-bootstrap';
import { Equirment } from 'src/app/models/equirment.model';
import { itemDetail } from 'src/app/models/itemDetail.model';
import { itemDetailService } from 'src/app/service/item-detail.service';
import { roomDetail } from 'src/app/models/roomDetail.model';
import { roomDetailService } from 'src/app/service/room-detail.service';
import { Room } from 'src/app/models/rooms.model';

@Component({
  selector: 'app-admin-pending',
  templateUrl: './admin-pending.component.html',
  styleUrls: ['./admin-pending.component.scss'],
  styles: [`
  .form-group.hidden {
    width: 0;
    margin: 0;
    border: none;
    padding: 0;
  }
  .custom-day {
    text-align: center;
    padding: 0.185rem 0.25rem;
    display: inline-block;
    height: 2rem;
    width: 2rem;
  }
  .custom-day.focused {
    background-color: #e6e6e6;
  }
  .custom-day.range, .custom-day:hover {
    background-color: rgb(2, 117, 216);
    color: white;
  }
  .custom-day.faded {
    background-color: rgba(2, 117, 216, 0.5);
  }
`]

})

export class AdminPendingComponent implements OnInit {
  page = 1;
  pageSize = 10;

  closeResult = '';

  listitemDetail : itemDetail[] = [];
  listroomDetail : roomDetail[] = [];

  modelEquirment = new Equirment();
  modelRoom = new Room();
  modelitemDetail = new itemDetail();
  modelroomDetail = new roomDetail();

  collectionSize = this.listitemDetail.length;
  hoveredDate: NgbDate | null = null;

  fromDate: NgbDate | null;
  toDate: NgbDate | null;

  thStime: string;
  thEtime: string;
  thtimeChange (time:string,item:any){
    let timeSplit = time.split(":")
    item.hour = parseInt(timeSplit[0])
    item.minute = parseInt(timeSplit[1])
    console.log(this.modelroomDetail)
  }


  constructor(private calendar: NgbCalendar, public formatter: NgbDateParserFormatter, private modalService: NgbModal, private itemDetailService: itemDetailService, private roomDetailService: roomDetailService) {
    this.fromDate = calendar.getToday();
    this.toDate = calendar.getNext(calendar.getToday(), 'd', 10);
    this.refreshitemDetail();
  }

  refreshitemDetail() {
    this.listitemDetail = this.listitemDetail
      .map((country, i) => ({ id: i + 1, ...country }))
      .slice((this.page - 1) * this.pageSize, (this.page - 1) * this.pageSize + this.pageSize);
  }

  onDateSelection(date: NgbDate) {
    if (!this.fromDate && !this.toDate) {
      this.fromDate = date;
    } else if (this.fromDate && !this.toDate && date && date.after(this.fromDate)) {
      this.toDate = date;
    } else {
      this.toDate = null;
      this.fromDate = date;
    }
  }

  open(content) {
    this.modalService.open(content, { ariaLabelledBy: 'modal-basic-title' }).result.then((result) => {
      this.closeResult = `Closed with: ${result}`;
    }, (reason) => {
      this.closeResult = `Dismissed ${this.getDismissReason(reason)}`;
    });
  }
  date='10-12-2561'
  show(a:string){
    console.log(a)
  }
  sDate = ""
  eDate = ""
  openItemDetail(content : string ,item : itemDetail) {
    this.modelitemDetail = item ;
    this.thStime= this.modelitemDetail.sTime.hour + ':' + this.modelitemDetail.sTime.minute 
    this.thEtime= this.modelitemDetail.eTime.hour + ':' + this.modelitemDetail.eTime.minute
    let SDate = this.modelitemDetail.sDate.split('/')
    this.sDate = SDate[2]+"-"+SDate[1]+"-"+SDate[0]
    let EDate = this.modelitemDetail.eDate.split('/')
    this.eDate = EDate[2]+"-"+EDate[1]+"-"+EDate[0]
    this.modalService.open(content, { ariaLabelledBy: 'modal-basic-title' }).result.then((result) => {
      this.closeResult = `Closed with: ${result}`;
    }, (reason) => {
      this.closeResult = `Dismissed ${this.getDismissReason(reason)}`;
    });
  }

  rDate(item: string, item2: string){
    let Dates = item.split("-")
    let dates = Dates[2]+"/"+Dates[1]+"/"+Dates[0]
    
    if(item2=="sdate"){
      this.modelitemDetail.sDate = dates
    }
    if(item2=="edate"){
      this.modelitemDetail.eDate = dates
    }
    console.log(this.sDate)
  } 

  openRoomDetail(content : string ,item : roomDetail) {
    this.modelroomDetail = item ;
    this.thStime= this.modelroomDetail.sTime.hour + ':' + this.modelroomDetail.sTime.minute 
    this.thEtime= this.modelroomDetail.eTime.hour + ':' + this.modelroomDetail.eTime.minute 
    let SDate = this.modelroomDetail.sDate.split('/')
    this.sDate = SDate[2]+"-"+SDate[1]+"-"+SDate[0]
    let EDate = this.modelroomDetail.eDate.split('/')
    this.eDate = EDate[2]+"-"+EDate[1]+"-"+EDate[0]
    this.modalService.open(content, { ariaLabelledBy: 'modal-basic-title' }).result.then((result) => {
      this.closeResult = `Closed with: ${result}`;
    }, (reason) => {
      this.closeResult = `Dismissed ${this.getDismissReason(reason)}`;
    });
  }

  private getDismissReason(reason: any): string {
    if (reason === ModalDismissReasons.ESC) {
      return 'by pressing ESC';
    } else if (reason === ModalDismissReasons.BACKDROP_CLICK) {
      return 'by clicking on a backdrop';
    } else {
      return `with: ${reason}`;
    }
  }

  isHovered(date: NgbDate) {
    return this.fromDate && !this.toDate && this.hoveredDate && date.after(this.fromDate) && date.before(this.hoveredDate);
  }

  isInside(date: NgbDate) {
    return this.toDate && date.after(this.fromDate) && date.before(this.toDate);
  }

  isRange(date: NgbDate) {
    return date.equals(this.fromDate) || (this.toDate && date.equals(this.toDate)) || this.isInside(date) || this.isHovered(date);
  }

  validateInput(currentValue: NgbDate | null, input: string): NgbDate | null {
    const parsed = this.formatter.parse(input);
    return parsed && this.calendar.isValid(NgbDate.from(parsed)) ? NgbDate.from(parsed) : currentValue;
  }

  ngOnInit(): void {
    this.listitemDetail = this.itemDetailService.getListitemDetail();
    this.listroomDetail = this.roomDetailService.getListroomDetail();
    console.log(this.listitemDetail);
  }


}

export class NgbdDropdownBasic {
}
